/***************************************************************************
* Config.h                                                                 *
*                                                                          *
* Fundamental constants used throughout the recognition and training       *
* software.                                                                *
*                                                                          *
*   Changes:                                                               *
*                                                                          *
*       12/21/97  arvo    major cleanup.                                   *
*       11/16/96  guo     Initial coding.                                  *
*                                                                          *
*--------------------------------------------------------------------------*
* Copyright (C) 1999, James Arvo                                           *
*                                                                          *
* This program is free software; you can redistribute it and/or modify it  *
* under the terms of the GNU General Public License as published by the    *
* Free Software Foundation.  See http://www.fsf.org/copyleft/gpl.html      *
*                                                                          *
* This program is distributed in the hope that it will be useful, but      *
* WITHOUT EXPRESS OR IMPLIED WARRANTY of merchantability or fitness for    *
* any particular purpose.  See the GNU General Public License for more     *
* details.                                                                 *
*                                                                          *
***************************************************************************/
#ifndef __CONFIG_INCLUDED__
#define __CONFIG_INCLUDED__

static const int 
  Max_Features          = 56,  // Upper bound on number of features.
  Max_Name_Length       = 127, // Limit on the length of file names.
  Max_Path_Length       = 255, // Limit on the length of path names.
  Max_Samples           = 100, // Limit on number of samples per symbol.
  Delay_Between_Strokes = 60;  // Milliseconds between strokes in Train program.

static const float
  SoftwareVersion       = 4.4, // Training & recognition software version.
  TD_Version            = 3.0, // Version of training data files.
  FM_Version            = 8.1; // Version of feature matrix files.

typedef void (*progress_meter)( int flag, const char * );

#define TD_VersionFormat "[Training Data: Version %g]\n"
#define FM_VersionFormat "[Feature Matrix: Version %g]\n"

#endif




