% Transform Turing program to an auto-tracing version of itself.
% (Test of the new generalized [quote] in TXL.)
% If this transform were to be completed, it would also indicate values 
% of assigned and passed variables and expressions in the trace.
% J.R. Cordy, 6.12.94

include "Turing.Grammar"

keys 
    DONE__
end keys

redefine declaration_or_statement
        [declaration]            [opt ';] [NL]         
    |   [variable_binding]       [opt ';] [NL]         
    |   [statement]              [opt ';] [NL]         [attr 'DONE__]
end redefine

function main
    replace [program]
        DandS [repeat declaration_or_statement]
    by
        DandS [addTracing]
end function

rule addTracing
    replace [repeat declaration_or_statement]
        S [statement] _ [opt ';]
        Rest [repeat declaration_or_statement]
    construct QuoteS [stringlit]
        _ [quote S]
    by
        put ">>> ", QuoteS    DONE__
        S                     DONE__
        Rest
end rule
