CREATE TABLE CONSULTANT (
    Fname CHARACTER (20) NOT NULL,
    Lname CHARACTER (20) NOT NULL,
    Address CHARACTER (40))
PRIMARY KEY (Fname, Lname)

CREATE TABLE EMPLOYEE (
    SIN INTEGER NOT NULL,
    Fname CHARACTER (20),
    Lname CHARACTER (20),
    Address CHARACTER (40),
    Department_Number INTEGER NOT NULL)
PRIMARY KEY (SIN)
FOREIGN KEY (Department_Number)
    REFERENCES DEPARTMENT

CREATE TABLE DEPARTMENT (
    Number INTEGER NOT NULL,
    Name CHARACTER (40) NOT NULL,
    Manager_SIN INTEGER NOT NULL,
    Manages_StartDate CHARACTER (8))
UNIQUE (Name)
UNIQUE (Manager_SIN)
PRIMARY KEY (Number)
FOREIGN KEY (Manager_SIN)
    REFERENCES EMPLOYEE

CREATE TABLE PROJECT (
    Name CHARACTER (40) NOT NULL,
    Controlling_dept_Number INTEGER NOT NULL)
PRIMARY KEY (Name)
FOREIGN KEY (Controlling_dept_Number)
    REFERENCES DEPARTMENT

CREATE TABLE SUPPLIER (
    Name CHARACTER (40) NOT NULL)
PRIMARY KEY (Name)

CREATE TABLE PART (
    Number INTEGER NOT NULL)
PRIMARY KEY (Number)

CREATE TABLE DEPENDENT (
    Relationship CHARACTER (40),
    Name CHARACTER (40) NOT NULL,
    Employee_SIN INTEGER NOT NULL)
PRIMARY KEY (Name, Employee_SIN)
FOREIGN KEY (Employee_SIN)
    REFERENCES EMPLOYEE 

CREATE TABLE WORKS_ON (
    Hours INTEGER,
    Worker_SIN INTEGER NOT NULL,
    Project_Name CHARACTER (40) NOT NULL)
PRIMARY KEY (Worker_SIN, Project_Name)
FOREIGN KEY (Worker_SIN)
    REFERENCES EMPLOYEE 
FOREIGN KEY (Project_Name)
    REFERENCES PROJECT 

CREATE TABLE SUPPLY (
    Quantity INTEGER,
    Project_Name CHARACTER (40) NOT NULL,
    Supplier_Name CHARACTER (40) NOT NULL,
    Part_Number INTEGER NOT NULL)
PRIMARY KEY (Project_Name, Supplier_Name, Part_Number)
FOREIGN KEY (Project_Name)
    REFERENCES PROJECT 
FOREIGN KEY (Supplier_Name)
    REFERENCES SUPPLIER 
FOREIGN KEY (Part_Number)
    REFERENCES PART 

CREATE TABLE DEPARTMENT_Locations (
    DEPARTMENT_Number INTEGER NOT NULL,
    Locations CHARACTER (40))
PRIMARY KEY (DEPARTMENT_Number, Locations)
FOREIGN KEY (DEPARTMENT_Number)
    REFERENCES DEPARTMENT

CREATE TABLE PROJECT_Locations (
    PROJECT_Name CHARACTER (40) NOT NULL,
    Building CHARACTER (40),
    Room CHARACTER (10))
PRIMARY KEY (PROJECT_Name, Building, Room)
FOREIGN KEY (PROJECT_Name)
    REFERENCES PROJECT



